package org.sinev.igor.ps.model;

import java.util.List;

import org.sinev.igor.collections.ThreadedList;
import org.sinev.igor.ps.PSParseException;

public interface IElementStructure {
	
	/**
	 * Gets the main list of the structure.
	 * 
	 * @return body of the structure.
	 */
	public ThreadedList getBody();
	
	/**
	 * Values that are left at the top of stack after 
	 * element processing.
	 * 
	 * @return list of resulting elements.
	 */
	public List<IStackObject> getOutgoingValues();
	
	/** 
	 * Gets the list of all structure elements
	 *  
	 * @return list of structure elements
	 */
	public List<IElement> getElementsList();

	/**
	 * Goes through the list and creates links
	 * between operators.
	 * 
	 * @throws PSParseException
	 */
	public void buildOperatorLinks() throws PSParseException;

}
