package org.sinev.igor.ps.model;

import java.util.List;

import org.sinev.igor.ps.elementtype.ElementType;

public interface IFunctionalElement extends IElement {
	
	/**
	 * Gets type of piece of output data produced by this element 
	 * by its number.
	 * 
	 * @param myNumber number of return value
	 * 
	 * @return type of return value
	 */
	public ElementType getReturnType(int myNumber);
	
	/**
	 * Performs partial interpretation and forms resulting 
	 * output data
	 *  
	 * @return list of return values of the element.
	 */
	public List<IElement> calculateReturns();

}
