package org.sinev.igor.ps.model.impl;

import org.sinev.igor.ps.elementtype.ElementType;
import org.sinev.igor.ps.model.IDocument;
import org.sinev.igor.ps.model.IPSEBoolean;


/**
 * Represents a boolean element of some PS document.
 * 
 * @author Igor Sinev
 */
public class PSEBoolean extends Element implements IPSEBoolean {

	private boolean myValue;	
	
	PSEBoolean(String representation, IDocument d) {
		super(representation, d);
		myValue = (representation == "true");
	}
	
	PSEBoolean(boolean v, Document d) {
		super(String.valueOf(v), d);
		myValue = v;		
	}
	
	/**
	 * Gets the value of an element.
	 * 
	 * @return element value.
	 */
	public boolean getValue() {
		return myValue;
	}

	public ElementType getType() {
		return ElementType.BOOL;
	}

	@Override
	public boolean isInterpretable() {
		return true;
	}
}
