package org.sinev.igor.ps.model.impl;

import org.sinev.igor.ps.PSParseException;
import org.sinev.igor.ps.elementtype.ElementType;
import org.sinev.igor.ps.model.IDocument;
import org.sinev.igor.ps.model.IStackObject;

/**
 * Represents call of the previously defined procedure.
 * 
 * @author Igor Sinev 
 */
public class PSEProcedureCall extends FunctionalElement {
	private PSEProcedureElement myProcedure;
	protected PSEProcedureCall(String representation, IDocument d) {
		super(representation, d);
		myProcedure = ((Document) d).getProcedure(representation);
	}
	
	@Override
	void putToStack(ElementStructure.StorageStack s) throws PSParseException {				
		for (ElementType t : myProcedure.getIncomingTypes()) {			
			IStackObject o = s.pop(t);
			ElementType ot = o.getType();						
			if (!ot.matches(t))
				throw new PSParseException("Element type doesn't match: expected " + t + ", found " + ot + ".");
						
			myArguments.add(o);			
		}
						
		int i = 0;
		for (ElementType ot : myProcedure.getOutgoingTypes()) {
			s.push(new CalculatedStackObject(this, i++, ot));
		}
	}

	@Override
	public ElementType getReturnType(int myNumber) {
		return myProcedure.getOutgoingTypes().get(myNumber);
	}	
}
