package org.sinev.igor.ps.model.impl;

import org.sinev.igor.ps.elementtype.ElementType;
import org.sinev.igor.ps.model.IDocument;
import org.sinev.igor.ps.model.IPSEWhitespace;

/**
 * Represents a whitespace element of some PS document.
 * 
 * @author Igor Sinev
 */
public class PSEWhitespace extends Element implements IPSEWhitespace {			
	public PSEWhitespace(String representation, IDocument d) {
		super(representation, d);		
	}
	
	public void listDebugOutput(StringBuffer target) {
		target.append("Whitespace: ");
		for (char c : myRepresentation.toCharArray())
			target.append("\\").append((int) c);
	}
	
	public boolean isInterpretable() {
		return false;
	}
	
	public ElementType getType() {
		throw new IllegalStateException("Objects of type " + this.getClass().getName() + " can't take part in interpretation data flow as operator arguments");
	}
}
