package org.sinev.igor.ps.reader;

import java.io.IOException;
import java.io.Reader;

import org.sinev.igor.ps.PSParseException;
import org.sinev.igor.ps.model.IDocument;
import org.sinev.igor.ps.model.IElement;
import org.sinev.igor.ps.model.IReader;

/**
 * Reads PS documents from ordinary Readers.
 * 
 * @author Igor 
 */
public class PSReader implements IReader {			  		
	
	private CountingPushbackReader myReader;
	
	/**
	 * Creates a PSReader based on specified Reader.
	 * 
	 * @param r source Reader.
	 */
	public PSReader(Reader r) {
		myReader = new CountingPushbackReader(r);
	}

	/**
	 * Reads an element for a specified document.
	 *  
	 * @param d destination document.
	 *  
	 * @return read element.
	 * 
	 * @throws PSParseException
	 */
	public IElement getNextElementFor(IDocument d) throws PSParseException {		
		try {
			return ElementReader.getTokenFromReader(myReader, d);
		} catch (IOException e) {
			throw new PSParseException(e);
		} 
	}		
}
