package org.sinev.igor.ps.tests;

import junit.framework.TestCase;

import org.sinev.igor.ps.elementtype.ElementType;

public class ElementTypeGetFromStringTest extends TestCase {
	private static void doTest(String val, ElementType type) {		
		assertEquals(val, type, ElementType.getFromString(val));
	}
	
	public void testBool1() {
		doTest("true", ElementType.BOOL);		
	}       
	
	public void testInt1() {
		doTest("-1", ElementType.INT);		
		}
	public void testInt2() {
		doTest("+1", ElementType.INT);		
	}
	public void testInt3() {
		doTest("17", ElementType.INT);		
	}
	public void testInt4() {
		doTest("0", ElementType.INT);		
	}

	public void testReal1() {
		doTest("-.002", ElementType.REAL);
	}
	public void testReal2() {
		doTest("34.5", ElementType.REAL);
	}
	public void testReal3() {
		doTest("-3.62", ElementType.REAL);
	}
	public void testReal4() {
		doTest("123.6e10", ElementType.REAL);
	}
	public void testReal5() {
		doTest("1.0E-5", ElementType.REAL);
	}
	public void testReal6() {
		doTest("1E6", ElementType.REAL);
	}
	public void testReal7() {
		doTest("-1.", ElementType.REAL);
	}
	public void testReal8() {
		doTest("0.0", ElementType.REAL);
	}
	
	public void testRadix1() {
		doTest("8#1777", ElementType.RADIX);
	}
	public void testRadix2() {
		doTest("16#FFFE", ElementType.RADIX);
	}
	public void testRadix3() {
		doTest("2#1000", ElementType.RADIX);
	}

	public void testCharacterString1() {
		doTest("(This is a string)", ElementType.CHARACTER_STRING);
	}
	public void testCharacterString2() {
		doTest("(Strings may contain newlines\nand such.)", ElementType.CHARACTER_STRING);
	}
	public void testCharacterString3() {
		doTest("(Strings may contain special characters *!&}^% and\nbalanced parentheses ( ) (and so on).)", ElementType.CHARACTER_STRING);
	}
	public void testCharacterString4() {
		doTest("()", ElementType.CHARACTER_STRING);
	}
	public void testCharacterString5() {
		doTest("(This string has a newline at the end of it.\n)", ElementType.CHARACTER_STRING);
	}
		    
    public void testNotInt1() {
    	assertFalse("0132", ElementType.INT == ElementType.getFromString("0132"));
    }
    
    public void testNotInt2() {
    	assertFalse("402134132-1", ElementType.INT == ElementType.getFromString("402134132-1"));
    }
    
    public void testNotInt3() {
    	assertFalse("--1", ElementType.INT == ElementType.getFromString("--1"));
    }
    
    public void testNotInt4() {
    	assertFalse("-1-", ElementType.INT == ElementType.getFromString("-1-"));
    }	

}
