package org.sinev.igor.psmisc;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;

public class HTMLDescriptionConverter {
	private static final String INPUT_FILENAME = "org/sinev/igor/psmisc/wwoutput.html";
	private static final String OUTPUT_FILENAME = "org/sinev/igor/psmisc/reference.txt";

	public static void main(String[] args) {
		try {
			BufferedReader in = new BufferedReader(new FileReader(new File(INPUT_FILENAME)));
			PrintWriter out = new PrintWriter(new File(OUTPUT_FILENAME));
			StringBuffer b = new StringBuffer();
			for (;;) {				
				try {
					String s = in.readLine();
					if (s == null)
						break;
					b.append(s).append(' ');					
				} catch (IOException e) {					
					e.printStackTrace();
				}				
			}
			String s = b.toString();
			ArrayList<String> resultingOutput = new ArrayList<String>();
			resultingOutput.add("");
			
			StringBuffer tb = new StringBuffer();
						
			while (s.length() > 0) {
				int paragraphEnd = s.indexOf("<p");
				if (paragraphEnd == -1)
					paragraphEnd = s.length();
				String t = s.substring(0, paragraphEnd);
				s = s.substring((paragraphEnd == s.length()) ? s.length() : s.indexOf('>', paragraphEnd) + 1, s.length());
				
				tb.setLength(0);
							
				while (t.length() > 0) {
					int tagStart = t.indexOf('<');				
					if (tagStart == -1) {
						tb.append(t);
						break;
					}
					tb.append(t.substring(0, tagStart));
					int tagEnd = t.indexOf('>', tagStart);
					String z = t.substring(tagStart, tagEnd + 1);
					if (z.equals("<b>") || z.equals("</i>"))
						tb.append(' ').append(z);
					else if (z.indexOf("9.5pt") > -1)
						tb.append(" <9.5pt>");
					t = t.substring(tagEnd + 1);
				}
				t = tb.toString();
				if (t.indexOf("<b>") > -1)
					resultingOutput.add(t);
				else {
					t = resultingOutput.get(resultingOutput.size() - 1) + t; 					
					resultingOutput.remove(resultingOutput.size() - 1);
					resultingOutput.add(t);
				}
			}
			for (String rs : resultingOutput)
				out.println(rs);
			out.close();
		} catch (FileNotFoundException e) {			
			e.printStackTrace();
		}
    
	}

}
